SystemOrganization addCategory: #'Mysql-Driver'!
SystemOrganization addCategory: #'Mysql-Tests'!
SystemOrganization addCategory: #'Mysql-Mocks'!

Object subclass: #JdmColumn
	instanceVariableNames: 'table name size type flags decimalPlaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
autoIncrementFlag
	^512! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
binaryFlag
	^128! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
blobFlag
	^16! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
blobType
	^252! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
dateType
	^10! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
datetimeType
	^12! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
decimalType
	^0! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
doubleType
	^5! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
enumFlag
	^256! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
enumType
	^247! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
floatType
	^4! !

!JdmColumn class methodsFor: 'instance creation' stamp: 'alnr 3/18/2007 00:05'!
fromResultSet: aResultSet

	^self new fromResultSet: aResultSet! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
int24Type
	^9! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
longBlobType
	^251! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
longType
	^3! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
longlongType
	^8! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
mediumBlobType
	^250! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
multipleKeyFlag
	^8! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
newDateType
	^14! !

!JdmColumn class methodsFor: 'constants-types' stamp: 'alnr 3/18/2007 05:06'!
newDecimalType
	^246! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
notNullFlag
	^1! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
nullType
	^6! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
primaryKeyFlag
	^2! !

!JdmColumn class methodsFor: 'instance creation' stamp: ''!
readFrom: aReadStream
	^self new readFrom: aReadStream! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
setType
	^248! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
shortType
	^2! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
stringType
	^254! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
timeType
	^11! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
timestampFlag
	^1024! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
timestampType
	^7! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
tinyBlobType
	^249! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
tinyType
	^1! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
uniqueKeyFlag
	^4! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
unsignedFlag
	^32! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
varStringType
	^253! !

!JdmColumn class methodsFor: 'constants-types' stamp: ''!
yearType
	^13! !

!JdmColumn class methodsFor: 'constants-flags' stamp: ''!
zerofillFlag
	^64! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
decimalPlaces
	^decimalPlaces! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
flags
	^flags! !

!JdmColumn methodsFor: 'reading' stamp: 'alnr 3/18/2007 03:14'!
fromResultSet: aResultSet

	| readStream |
	readStream := aResultSet connection responsePacket  readStream .

	aResultSet serverVersion printString < '4.1' ifTrue:[
		^self readFrom40: readStream].
	self readFrom: readStream! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
hasFlag: aFlag
	^(self flags bitAnd: aFlag) > 0! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isAutoIncrement
	^self hasFlag: self class autoIncrementFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isBinary
	^self hasFlag: self class binaryFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isBlob
	^self hasFlag: self class blobFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isEnumeration
	^self hasFlag: self class enumFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isMultipleKey
	^self hasFlag: self class multipleKeyFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isNotNull
	^self hasFlag: self class notNullFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isPrimaryKey
	^self hasFlag: self class primaryKeyFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isTimestamp
	^self hasFlag: self class timestampFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isUniqueKey
	^self hasFlag: self class uniqueKeyFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isZerofill
	^self hasFlag: self class zerofillFlag! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:39'!
name
	^name! !

!JdmColumn methodsFor: 'reading' stamp: 'alnr 3/18/2007 04:28'!
printOn: s

	s 
		nextPutAll: table asString
	;	nextPut: $.
	;	nextPutAll: name asString ;	space
	;	nextPut: $(
	;	nextPutAll: size asString	; space
	;	nextPutAll: type asString ; space
	;	nextPutAll: flags asString ; space
	;	nextPutAll: decimalPlaces asString
	;	nextPut: $)
		! !

!JdmColumn methodsFor: 'reading' stamp: 'alnr 3/18/2007 02:01'!
readCatalog: aReadStream

	"just tossing the catalog right now"
	
	 (aReadStream next: aReadStream next asInteger)! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:39'!
readDecimalPlaces: aReadStream
	decimalPlaces _ aReadStream next asInteger! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:39'!
readFlags: aReadStream 
	"Currently the size of both the flags field and decimalPlaces field is specified as a sum of the two.
        I am guessing that the size of the flags is more likely to change than that of the decimalPlaces.
        Right now I assume that the flags are all bytes but the last and that the last is the decimalPlaces"
	| ba |
	ba _ (aReadStream next: aReadStream next asInteger - 1) asByteArray.
	flags _ JdmConnection byteArrayAsInteger: ba.
				 ! !

!JdmColumn methodsFor: 'reading' stamp: 'alnr 3/18/2007 00:08'!
readFrom40: aReadStream 
	self
		readTable: aReadStream;
		readName: aReadStream;
		readSize: aReadStream;
		readType: aReadStream;
		readFlags: aReadStream;
		readDecimalPlaces: aReadStream! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:40'!
readFrom: aReadStream 
	self
		readTable: aReadStream;
		readName: aReadStream;
		readSize: aReadStream;
		readType: aReadStream;
		readFlags: aReadStream;
		readDecimalPlaces: aReadStream! !

!JdmColumn methodsFor: 'reading' stamp: 'alnr 3/18/2007 03:16'!
readLCS: aReadStream
	
	 ^(aReadStream next: aReadStream next asInteger)! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:40'!
readName: aReadStream
	name _ (aReadStream next: aReadStream next asInteger)! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:59'!
readSize: aReadStream
"
	size _ (aReadStream next: aReadStream next asInteger) asByteArray asInteger
"
	| ba |
	ba _ (aReadStream next: aReadStream next asInteger) asByteArray.
	size _ JdmConnection byteArrayAsInteger: ba! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:41'!
readTable: aReadStream
	table _ (aReadStream next: aReadStream next asInteger)! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:41'!
readType: aReadStream
	| ba |
	ba _ (aReadStream next: aReadStream next asInteger) asByteArray.
	type _ JdmConnection byteArrayAsInteger: ba.
 ! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:39'!
size
	^size! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:39'!
table
	^table! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:39'!
type
	^type! !

JdmColumn subclass: #JdmMockColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Mocks'!

!JdmMockColumn methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2002 14:43'!
decimalPlaces: anInteger
	decimalPlaces _ anInteger.! !

!JdmMockColumn methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2002 14:43'!
flags: anInteger
	flags _ anInteger.! !

!JdmMockColumn methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2002 14:43'!
name: aString
	name _ aString.! !

!JdmMockColumn methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2002 14:43'!
size: anInteger
	size _ anInteger.! !

!JdmMockColumn methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2002 14:43'!
table: aString
	table _ aString.! !

!JdmMockColumn methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2002 14:44'!
type: anInteger
	type _ anInteger.! !

Object subclass: #JdmConnection
	instanceVariableNames: 'socket readStream writeStream serverInfo hashesByProtocol responsePacket clientCapabilities connectionSpec packetClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:46'!
byteArrayAsByteString: ba
	| size s |
	size := ba size.
	s := String new: size.
	1 to: size do: [:index |
		s at: index put: ((ba at: index) asCharacter).
	].
	^s.! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:39'!
byteArrayAsInteger: ba
	^self byteArrayAsInteger: ba from: 1 for: ba size

! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:34'!
byteArrayAsInteger: ba from: anOffset for: aLength 
 
	| shiftAmount anInteger |
	
	shiftAmount := 0.
	
	anInteger := 0.
	
	anOffset to: aLength
 do: 
[:index | 
			
	anInteger := anInteger bitOr: ((ba at: index) bitShift: shiftAmount).
		
	shiftAmount := shiftAmount + 8].
	
	^anInteger
! !

!JdmConnection class methodsFor: 'instance creation' stamp: 'alnr 5/27/2007 16:26'!
connect: aConnectionSpec 
	
	^self new
		connectionSpec: aConnectionSpec
	;	initialize2! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:22'!
hash1: aString seed: aSeed 
	
	"This algorithm is for protocol 9."

	
	| hashedString maxValue array num1 num2 num3 |
	
	hashedString := String new: aSeed size.
	
	array := self randomInit1: aString seed: aSeed.
	
	maxValue := array at: 1.
	
	num1 := array at: 2.

	num2 := array at: 3.
	
	1 to: hashedString size
 do: 
[:index | 
			
		num1 := (num1 * 3 + num2) \\ maxValue.
			
		num2 := (num1 + num2 + 33) \\ maxValue.
			
		num3 := (num1 / maxValue * 31) truncated + 64.
			
		hashedString at: index put: num3 asCharacter].
	
	^hashedString! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:23'!
hash2: aString seed: aSeed 
	
	"This algorithm is for clientProtocol 10."

	
	| hashedString maxValue result num1 num2 num3 |
	
	hashedString := String new: aSeed size.
	
	result := self randomInit2: aString seed: aSeed.
	
	maxValue := result at: 1.

	num1 := result at: 2.
	
	num2 := result at: 3.
	
	1 to: hashedString size
 do: 
[:index | 
			
		num1 := (num1 * 3 + num2) \\ maxValue.
			
		num2 := (num1 + num2 + 33) \\ maxValue.
			
		num3 := (num1 / maxValue * 31) truncated + 64.
			
		hashedString at: index put: num3 asCharacter].
	
	num1 := (num1 * 3 + num2) \\ maxValue.
	
	num2 := (num1 + num2 + 33) \\ maxValue.
	
	num3 := (num1 / maxValue * 31) truncated.
	
	hashedString inject: 1
 into: 
[:index :character | 
			
		hashedString at: index put: (character asInteger bitXor: num3) asCharacter.
			
		index + 1].
	
	^hashedString! !

!JdmConnection class methodsFor: 'hashing' stamp: 'alnr 5/27/2007 16:47'!
hash3: aString seed: aSeed 

	| hash1 hash2 salt saltPass xor sha shaSaltPass |
	sha := SecureHashAlgorithm.
	hash1 := sha new hashMessage: aString.
	hash2 := sha new hashMessage: hash1 asByteArray .
	salt := aSeed .
	saltPass := salt asByteArray , hash2 asByteArray .
	shaSaltPass := sha new hashMessage: saltPass .
	xor := hash1 bitXor: shaSaltPass .
	^xor asByteArray asString

	"
	self hash3: 'abc' seed: 'blah' 
  	" ! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:24'!
hash: aString 
	
	"Hash algorithm taken from mysql in order to send password to the server"

	
	| num1 num2 num3 charValue |
	
	num1 := 1345345333.
	
	num2 := 305419889.
	
	num3 := 7.
	
	aString do: 
	[:character | 
			
		(character = Character space or: [character = Character tab]) 
				
		ifFalse: 
[
					
			charValue := character asInteger.
					
			num1 := num1 
bitXor: ((num1 bitAnd: 63) + num3) * charValue + (num1 bitShift: 8).
					
			num2 := num2 + ((num2 bitShift: 8) bitXor: num1).
					
			num3 := num3 + charValue]].
	
	^Array with: (num1 bitAnd: 2147483647) with: (num2 bitAnd: 2147483647)! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:36'!
integerAsByteArray: int length: aLength 

	| aByteArray shiftAmount mask |

	aByteArray := ByteArray new: aLength.

	shiftAmount := 0.
	
	mask := 16rFF.
	
	1 to: aLength
 do: 
[:index | 
			
		aByteArray at: index put: (mask bitAnd: (int bitShift: shiftAmount)).
			
		shiftAmount := shiftAmount - 8].
	
	^aByteArray
! !

!JdmConnection class methodsFor: 'constants' stamp: 'jb 2/28/1999 19:21'!
largeSizesVersion
	
	^(JdmServerVersion new initialize)
		
		fileFormat: 3;
		
		serverRelease: 22;
		
		version: 7! !

!JdmConnection class methodsFor: 'instance creation' stamp: 'alnr 9/6/2004 22:08'!
on: aConnectionSpec 
	
	^(self new)
	connectionSpec: aConnectionSpec;
 initialize2! !

!JdmConnection class methodsFor: 'constants' stamp: 'jb 2/28/1999 19:21'!
protocolHashes
	
	^#(9 #hash1:seed:
          
		10 #hash2:seed:)! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:25'!
randomInit1: aString seed: aSeed 
	
	| result array1 array2 |
	
	result := Array new: 3.
	
	array1 := self hash: aString.
	
	array2 := self hash: aSeed.
	
	result at: 1 put: 16r01FFFFFF.
	
	result at: 2 put: ((array1 at: 1) bitXor: (array2 at: 1)) \\ (result at: 1).
	result at: 3 put: (result at: 2) // 2.
	
	^result! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:25'!
randomInit2: aString seed: aSeed 
	
	| result array1 array2 |
	
	result := Array new: 3.
	
	array1 := self hash: aString.
	
	array2 := self hash: aSeed.
	
	result at: 1 put: 16r3FFFFFFF.
	
	result at: 2 put: ((array1 at: 1) bitXor: (array2 at: 1)) \\ (result at: 1).
	result at: 3 put: ((array1 at: 2) bitXor: (array2 at: 2)) \\ (result at: 1).
	
	^result! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:32'!
symbolAsClass: aSymbol
	^Smalltalk at: aSymbol.
! !

!JdmConnection class methodsFor: 'instance creation' stamp: 'alnr 5/27/2007 16:30'!
temp

	[^  3 / 0 ] on: Error do:[^9]! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/4/1999 20:35'!
test
"

| connection statement resultSet value |
connection := JdmConnection on: 
  
(JdmConnectionSpec new initialize user: 'root'; password: 'p').
statement := connection createStatement.


resultSet := statement executeQuery: 'select * from person'.


[resultSet next] whileTrue: [value := resultSet valueNamed: 'name'.
Transcript show: value printString.
Transcript cr.
]
"! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'alnr 4/7/2007 04:29'!
authenticate40

	| replyStream password |
	replyStream  := self replyPacket writeStream .
	password := self class hash2: connectionSpec password 
		seed: (self serverInfo hashSeed copyFrom:1 to:8).
	replyStream nextPutAllNullTerminated: password .
	replyStream flush .
	^self responsePacket ! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:37'!
clientCapabilities
	^clientCapabilities! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 12/16/1999 16:31'!
close
	self
	closeRequest;
		closeReadStream;
		closeWriteStream;
		closeSocket! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 12/16/1999 16:32'!
closeReadStream
	responsePacket _ nil.	
	readStream isNil ifFalse: [readStream close].
	readStream _ nil! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 12/16/1999 16:32'!
closeRequest
	(self requestPacket writeStream) nextPutCommand:
		(JdmMysqlCommand withCommandNamed: #quit message: '');
		flush! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 1/10/2000 16:21'!
closeSocket
	(socket notNil and: [socket isValid])
		ifTrue: [socket close].
	socket _ nil! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 12/16/1999 16:31'!
closeWriteStream
	writeStream isNil ifFalse: [writeStream close].
	writeStream _ nil! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:37'!
connectionSpec
	^connectionSpec! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:37'!
connectionSpec: anObject
	connectionSpec _ anObject! !

!JdmConnection methodsFor: 'accessing' stamp: 'wh 12/12/2005 14:39'!
createStatement
	^JdmStatement on: self! !

!JdmConnection methodsFor: 'closing' stamp: 'tkow 10/29/2008 14:11'!
finalize
	[self close] ifError: []! !

!JdmConnection methodsFor: 'closing' stamp: 'alnr 3/25/2007 10:32'!
getCaps

	| answer int |
	int := self serverInfo options.
	answer := ByteArray new:4 .
	1 to:4 do: [ : n |
		answer at: n
			put: (int digitAt:n)].
	^answer
		! !

!JdmConnection methodsFor: 'hashing' stamp: 'bolot 12/16/1999 16:37'!
getHashFor: aProtocol 
	^hashesByProtocol at: aProtocol ifAbsent: [nil]! !

!JdmConnection methodsFor: 'hashing' stamp: 'bolot 12/16/1999 16:37'!
hash: aString seed: aSeed for: aProtocol 
	| aHashMethod |
	aHashMethod _ self getHashFor: aProtocol.
	aHashMethod isNil ifTrue: [^aString].
	^self class perform: aHashMethod with: aString with: aSeed! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'alnr 9/6/2004 22:08'!
initialize2

	"Renamed from #initialize because Behavior>>#new was changed in 8/03 to call #initialize, which broke this code. The rename ensures this code is called at the same time as before. cf. JdmInputPacket JdmOutputPacket JdmResultSet and JdmRow"
	
		self 
			initializeConnection;
			initializeUser;
			initializeDatabase! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'tkow 12/1/2008 11:21'!
initializeConnection
	| a |
	packetClass := JdmInputPacket.
     a := self class protocolHashes.
	(hashesByProtocol := Dictionary new)
		at: (a at: 1) put: (a at: 2);
		at: (a at: 3) put: (a at: 4).

	socket := Socket new
		connectTo: (connectionSpec host)
		port: (connectionSpec port).
	(socket waitForConnectionFor: OldSocket standardDeadline)
		"ifFalse: [Transcript cr; show: 'not connected']".
	(Smalltalk at: #FastSocketStream ifAbsent:[
		readStream := writeStream := SocketStream on: socket.
	]) ifNotNil:[
			readStream := writeStream := SocketStream on: socket.
	].

	serverInfo := JdmServerInfo on: self.
	serverInfo serverVersion >= self class largeSizesVersion
		ifTrue: [packetClass := JdmLargeSizeInputPacket].

	clientCapabilities := serverInfo protocol = 10 ifTrue: [1] ifFalse: [0]! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:35'!
initializeDatabase
	(self requestPacket writeStream)
	nextPutCommand: 
		(JdmMysqlCommand withCommandNamed: #initializeDatabase
			message: connectionSpec database);
	flush.
	self responsePacket checkStatusOnError: #setDatabase! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:58'!
initializeUser
	| replyStream password c s |
	password _ connectionSpec password isEmpty 
		ifTrue: ['']
		ifFalse: [self hash: connectionSpec password
			seed: self serverInfo hashSeed
			for: self serverInfo protocol].

	replyStream _ self replyPacket writeStream.

	c _ String new: 2.
	c at: 1 put: (self clientCapabilities) asCharacter.
	c at: 2 put: 0 asCharacter.
	s _ String new: 3.
	s at: 1 put: 0 asCharacter.
	s at: 2 put: 0 asCharacter.
	s at: 3 put: 1 asCharacter.

	replyStream
		nextPutAll: c;
		nextPutAll: s;
		nextPutAllNullTerminated: connectionSpec user;
		nextPutAllNullTerminated: password.

"
	replyStream
	 nextPutAll: (self clientCapabilities asByteArray: 2) asByteString;
				nextPutAll: (65536 asByteArray: 3) asByteString;
				nextPutAllNullTerminated: connectionSpec user;
				nextPutAllNullTerminated: password.
"
	replyStream flush.
	self responsePacket checkStatusOnError: #authenticate! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'alnr 3/19/2007 05:25'!
initializeUser40
	| replyStream password c s |
	password _ connectionSpec password isEmpty 
		ifTrue: ['']
		ifFalse: [self hash: connectionSpec password
			seed: self serverInfo hashSeed
			for: self serverInfo protocol].

	replyStream _ self replyPacket writeStream.

	c _ String new: 2.
	c at: 1 put: (self clientCapabilities) asCharacter.
	c at: 2 put: 0 asCharacter.
	s _ String new: 3.
	s at: 1 put: 0 asCharacter.
	s at: 2 put: 0 asCharacter.
	s at: 3 put: 1 asCharacter.

	replyStream
		nextPutAll: c;
		nextPutAll: s;
		nextPutAllNullTerminated: connectionSpec user;
		nextPutAllNullTerminated: password.

"
	replyStream
	 nextPutAll: (self clientCapabilities asByteArray: 2) asByteString;
				nextPutAll: (65536 asByteArray: 3) asByteString;
				nextPutAllNullTerminated: connectionSpec user;
				nextPutAllNullTerminated: password.
"
	replyStream flush.
	self responsePacket checkStatusOnError: #authenticate! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'alnr 3/19/2007 05:35'!
is40

	^self serverInfo   serverVersion asString < '4.1' ! !

!JdmConnection methodsFor: 'accessing' stamp: 'alnr 3/18/2007 01:18'!
lastResponsePacket

	responsePacket notNil ifTrue:[^responsePacket].
	^self responsePacket! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:59'!
replyPacket
	"| s |
	s _ String new: 2000.
	writeStream _ WriteStream on: s from: 1 to: (s size).
"
	^(JdmOutputPacket on: writeStream) 
		packetNumber: responsePacket packetNumber + 1! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
requestPacket
	^JdmOutputPacket on: writeStream ! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:59'!
responsePacket
"socket waitForDataQueryingUserEvery: 30."
	"socket dataAvailable ifFalse: [self error: 'socket data notavailable.']."
"
	buf _ socket getData.
Transcript show: buf; cr.
	readStream _ ReadStream on: buf.
"
	^responsePacket _ JdmInputPacket on: readStream
	
	! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
serverInfo
	^serverInfo! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
serverInfo: anObject
	serverInfo _ anObject! !

!JdmConnection methodsFor: 'accessing' stamp: 'alnr 3/17/2007 23:46'!
serverVersion

	^self serverInfo serverVersion! !

!JdmConnection methodsFor: 'accessing' stamp: 'tk 7/18/2008 16:02'!
socket
	^socket! !

Object subclass: #JdmConnectionSpec
	instanceVariableNames: 'database host port user password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmConnectionSpec methodsFor: 'accessing' stamp: ''!
database
	^database! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:42'!
database: anObject
	database _ anObject! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: ''!
host
	^host! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:43'!
host: anObject
	host _ anObject! !

!JdmConnectionSpec methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:43'!
initialize
	database _ 'joerg'.
	"host _ 'localhost'."
	host _ NetNameResolver localHostAddress.
	port _ 3306.
	user _ ''.
	password _ ''! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: ''!
password
	^password! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:43'!
password: anObject
	password _ anObject! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: ''!
port
	^port! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:43'!
port: anObject
	port _ anObject! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: ''!
user
	^user! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:43'!
user: anObject
	user _ anObject! !

Object subclass: #JdmDateHolder
	instanceVariableNames: 'date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmDateHolder class methodsFor: 'instance creation' stamp: 'bolot 2/10/2000 08:30'!
readFrom: aStream 
	^self new
		value: (JdmTimestampPrintPolicy timestampPrintPolicy reader 
				readMysqlDateFrom: aStream)! !

!JdmDateHolder methodsFor: 'intialize-release' stamp: 'bolot 12/16/1999 16:58'!
initialize
	date _ Date today! !

!JdmDateHolder methodsFor: 'printing' stamp: 'bolot 2/10/2000 08:41'!
printOn: aStream 
	| aPolicy tokens |
	(aStream respondsTo: #policy)
		ifTrue:
			[aPolicy _ aStream policy dateAndTimePolicy.
			tokens _ JdmTimestampPrintPolicy timestampPrintPolicy policyNamed: #JdmDate.
			aPolicy
				print: date
				on: aStream
				policy: tokens]
		ifFalse:
			[date printOn: aStream format: #(3 2 1 $- 1 1 2 )]! !

!JdmDateHolder methodsFor: 'accessing' stamp: ''!
value
	^date! !

!JdmDateHolder methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:58'!
value: aDate
	date _ aDate! !

Object subclass: #JdmDateTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

Object subclass: #JdmErrorTable
	instanceVariableNames: 'errors'
	classVariableNames: 'ErrorTable'
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmErrorTable class methodsFor: 'singleton' stamp: ''!
errorTable
	ErrorTable isNil ifTrue: [ErrorTable := self new initialize].
	^ErrorTable! !

!JdmErrorTable class methodsFor: 'errors' stamp: ''!
errorTableMap
	"JdmErrorTable resetErrorTable"
	^#(#protocol 'Invalid Protocol'
	    #authentication 'Access denied'
	    #setDatabase   'Could not set the database'
	    #invalidQuery 'Invalid query'
	    #invalidSize    'Read size out of bounds')! !

!JdmErrorTable class methodsFor: 'singleton' stamp: ''!
resetErrorTable
	ErrorTable := nil! !

!JdmErrorTable methodsFor: 'accessing' stamp: ''!
errors
	^errors! !

!JdmErrorTable methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 18:17'!
initialize
	errors _ IdentityDictionary new.
	self class errorTableMap pairsDo: [:key :value | errors at: key put: value]! !

!JdmErrorTable methodsFor: 'actions' stamp: ''!
throwException: aSymbol 
	self throwException: aSymbol message: ''! !

!JdmErrorTable methodsFor: 'actions' stamp: ''!
throwException: aSymbol message: aString 
	self 
		error: (self errors at: aSymbol ifAbsent: ['Unknown']) , ': ' , aString! !

Object subclass: #JdmFieldConverter
	instanceVariableNames: 'types converterSelectors'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmFieldConverter class methodsFor: 'singleton' stamp: ''!
fieldConverter
	Instance isNil ifTrue: [Instance := self new initialize].
	^Instance! !

!JdmFieldConverter class methodsFor: 'as yet unclassified' stamp: 'wh 3/3/2006 10:23'!
initialize
	self reset.! !

!JdmFieldConverter class methodsFor: 'singleton' stamp: 'cwp 8/23/2002 12:44'!
reset
	"JdmFieldConverter reset"
	Instance := nil! !

!JdmFieldConverter methodsFor: 'private-initialize' stamp: 'wh 11/28/2005 21:19'!
buildConversionMap
	converterSelectors := IdentityDictionary new.
	converterSelectors
		at: #Fraction put: #writeFraction:on:;
		at: #Double put: #writeDouble:on:;
		at: #Float put: #writeFloat:on:;
		at: #Time put: #writeQuotedTime:on:;
		at: #TimeStamp put: #writeQuotedTimestamp:on:;
		at: #Date put: #writeQuotedDate:on:;
		at: #Set put: #writeSet:on:;
		at: #JdmDateTime put: #writeQuotedJdmDateTime:on:! !

!JdmFieldConverter methodsFor: 'private-initialize' stamp: 'wh 3/3/2006 10:20'!
buildTypeMap
	types := Dictionary new.
	types
		at: JdmColumn tinyType put: #toInteger:column:;
		at: JdmColumn shortType put: #toInteger:column:;
		at: JdmColumn longType put: #toInteger:column:;
		at: JdmColumn int24Type put: #toInteger:column:;
		at: JdmColumn longlongType put: #toInteger:column:;
		at: JdmColumn floatType put: #toFloat:column:;
		at: JdmColumn doubleType put: #toDouble:column:;
		at: JdmColumn decimalType put: #toDouble:column:;
		at: JdmColumn dateType put: #toDate:column:;
		at: JdmColumn datetimeType put: #toDateTime:column:;
		at: JdmColumn timeType put: #toTime:column:;
		at: JdmColumn timestampType put: #toTimestamp:column:;
		at: JdmColumn enumType put: #toString:column:;
		at: JdmColumn setType put: #toSet:column:;
		at: JdmColumn tinyBlobType put: #toByteArray:column:;
		at: JdmColumn mediumBlobType put: #toByteArray:column:;
		at: JdmColumn longBlobType put: #toByteArray:column:;
		at: JdmColumn blobType put: #toByteArray:column:;
		at: JdmColumn varStringType put: #toString:column:;
		at: JdmColumn stringType put: #toString:column:.
		! !

!JdmFieldConverter methodsFor: 'actions' stamp: 'wh 3/3/2006 10:31'!
convert: aValue from: aColumn 
	"Dont treat DateTime as binary
		Should I even recnoize the binary flag at all?
		No!! It seams that it is only meant to be used 
		for string (or am I wrong)"
	"^ (aColumn isBinary) & (aColumn type ~= JdmColumn datetimeType)
		ifTrue: [self toByteArray: aValue column: aColumn]
		ifFalse: 
			[self perform: (types at: aColumn type)
			with: aValue
			with: aColumn]"
	^self perform: (types at: aColumn type)
			with: aValue
			with: aColumn.! !

!JdmFieldConverter methodsFor: 'actions' stamp: 'cwp 8/20/2002 17:20'!
convertToMysql: aValue 
	| writeStream |
	writeStream := WriteStream on: String new.
	self convertToMysql: aValue on: writeStream.
	^writeStream contents! !

!JdmFieldConverter methodsFor: 'actions' stamp: 'cwp 8/21/2002 13:56'!
convertToMysql: aValue on: aStream 
	| aSelector |
	aSelector := converterSelectors at: aValue class name
				ifAbsent: 
					[aValue printOn: aStream.
					^self].
	^self 
		perform: aSelector
		with: aValue
		with: aStream
! !

!JdmFieldConverter methodsFor: 'initialize-release' stamp: 'cwp 8/20/2002 17:19'!
initialize
	self buildTypeMap.
	self buildConversionMap! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'cwp 8/23/2002 01:41'!
toByteArray: aString column: aColumn 
	^ (aString isNil and: [aColumn isNotNull])
		ifTrue: [ByteArray new: 0]
		ifFalse:	[aString ifNotNil: [aString asByteArray]]! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'wh 3/3/2006 10:27'!
toDate: aString column: aColumn
	aString ifNil:[^nil].
	(aString asString = '0000-00-00') ifTrue:[
			^nil.
		] ifFalse: [
		 ^(Date
					year:
						(((aString) asString truncateTo: 4) asInteger) 
					month: 
						((aString asString copyFrom: 6 to:7) asInteger)
					day: 
						((aString asString copyFrom: 9 to:10) asInteger)
			)
		]! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'wh 3/3/2006 09:58'!
toDateTime: aString column: aColumn 
	(aString asString = '0000-00-00 00:00:00') ifTrue:[
			^nil.
		] ifFalse: [
			^(
				DateAndTime 
					year:
						(((aString) asString truncateTo: 4) asInteger) 
					month: 
						((aString asString copyFrom: 6 to:7) asInteger)
					day: 
						((aString asString copyFrom: 9 to:10) asInteger)
					hour: 
						((aString asString copyFrom: 12 to:13) asInteger)
					minute:
						((aString asString copyFrom: 15 to:16) asInteger)
					second:
						((aString asString copyFrom: 18 to:19) asInteger)
				)	
				
		]
	"^JdmDateTime readFrom: (ReadStream on: aString)"! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'cwp 8/21/2002 18:16'!
toFloat: aString column: aColumn
	^ Float readFrom: aString! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'cwp 8/22/2002 17:20'!
toFraction: aString column: aColumn
	| numerator denominator |
	^ aString ifNotNil:
		[numerator _ Integer readFromString: (aString copyWithout: $.).
		denominator _ 10 raisedTo: (aString size - (aString indexOf: $.)).
	 	numerator / denominator].
	! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'cwp 8/22/2002 17:21'!
toInteger: aString column: aColumn
	^ aString ifNotNil:
		[Integer readFrom: (ReadStream on: aString)]! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'cwp 8/22/2002 16:49'!
toSet: aString column: aColumn
	^ (aString isNil)
		ifTrue: [Set new]
		ifFalse: 	[(aString findTokens: $,) asSet].! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'cwp 8/22/2002 23:10'!
toString: aString column: aColumn
	"self halt."
	^ (aString isNil and: [aColumn isNotNull])
		ifTrue: ['']
		ifFalse: [aString].! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'cwp 8/21/2002 18:00'!
toTime: aString column: aColumn
	^ (JdmTimeHolder readFrom: (ReadStream on: aString)) value! !

!JdmFieldConverter methodsFor: 'converting' stamp: 'cwp 8/22/2002 16:21'!
toTimestamp: aString column: aColumn
	| stream |
	stream _ ReadStream on: aString.
	^ (aColumn type = JdmColumn timestampType)
		ifTrue: [(JdmTimestampHolder readFrom: stream) value]
		ifFalse: 
			[ | date time |
			date _ (JdmDateHolder readFrom: stream) value.
			stream next.
			time _ (JdmTimeHolder readFrom: stream) value.
			TimeStamp date: date time: time].
			! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/20/2002 17:44'!
writeDate: aDate on: aStream
	aDate printOn: aStream format: #(3 2 1 $- 1 1 2)! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/20/2002 17:21'!
writeDouble: aDouble on: aStream 
	| readStream character |
	readStream := ReadStream on: aDouble printString.
	
	[character := readStream next.
	character isNil] whileFalse: 
				[character = $d 
					ifTrue: 
						[character := readStream next.
						character isNil ifTrue: [^self].
						aStream nextPut: $e.
						character = $- ifFalse: [aStream nextPut: $+]].
				aStream nextPut: character]! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/20/2002 17:22'!
writeFloat: aFloat on: aStream 
	| readStream character |
	readStream := ReadStream on: aFloat printString.
	
	[character := readStream next.
	character isNil] whileFalse: 
				[character = $e 
					ifTrue: 
						[aStream nextPut: character.
						character := readStream next.
						character = $- ifFalse: [aStream nextPut: $+]].
				aStream nextPut: character]
! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/22/2002 15:48'!
writeFraction: aFraction on: aStream 
	self writeFloat: aFraction asFloat on: aStream! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/20/2002 17:22'!
writeJdmDateTime: aJdmDateTime on: aStream 
	self writeDate: aJdmDateTime date on: aStream.
	aStream nextPut: $ .
	self writeTime: aJdmDateTime time on: aStream
! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/20/2002 17:45'!
writeQuotedDate: aDate on: aStream
	aStream nextPut: $'.
	self writeDate: aDate on: aStream.
	aStream nextPut: $'.
! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/20/2002 17:40'!
writeQuotedJdmDateTime: aJdmDateTime on: aStream
	aStream nextPut: $'.
	self writeJdmDateTime: aJdmDateTime on: aStream.
	aStream nextPut: $'
! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/20/2002 17:25'!
writeQuotedTime: aTime on: aStream
	aStream nextPut: $'.
	self writeTime: aTime on: aStream.
	aStream nextPut: $'.
! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/20/2002 17:25'!
writeQuotedTimestamp: aTimestamp on: aStream
	aStream nextPut: $'.
	self writeTimestamp: aTimestamp on: aStream.
	aStream nextPut: $'.! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/22/2002 18:47'!
writeSet: aSet on: aStream
	"We assume this is a set of strings or symbols because
	it's meaningless to store sets of other objects in the database."
	
	aStream nextPut: $'.
	aSet
		do: [ :element | aStream nextPutAll: element ]
		separatedBy: [ aStream nextPut: $,].
	aStream nextPut: $'! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/20/2002 17:37'!
writeTime: aTime on: aStream
	aTime print24: true showSeconds: true on: aStream! !

!JdmFieldConverter methodsFor: 'converting-smalltalk' stamp: 'cwp 8/21/2002 12:19'!
writeTimestamp: aTimestamp on: aStream
	| date time |
	date _ aTimestamp date.
	time _ aTimestamp time.
	date printOn: aStream format: #(3 2 1 $- 1 1 2).
	aStream nextPut: $ .
	time print24: true showSeconds: true on: aStream.
! !

Object subclass: #JdmMysqlCommand
	instanceVariableNames: 'command message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
connect
	^11! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
createDatabase
	^5! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
debug
	^13! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
dropDatabase
	^6! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
fieldList
	^4! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
initializeDatabase
	^2! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
killProcess
	^12! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
processInfo
	^10! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
query
	^3! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
quit
	^1! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
refresh
	^7! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
shutdown
	^8! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
sleep
	^0! !

!JdmMysqlCommand class methodsFor: 'mysql-constants' stamp: ''!
statistics
	^9! !

!JdmMysqlCommand class methodsFor: 'instance creation' stamp: ''!
withCommand: aCommand 
	^self withCommand: aCommand message: nil! !

!JdmMysqlCommand class methodsFor: 'instance creation' stamp: ''!
withCommand: aCommand message: aMessage 
	^(self new)
		command: aCommand;
		message: aMessage! !

!JdmMysqlCommand class methodsFor: 'instance creation' stamp: ''!
withCommandNamed: aCommandName
	^self withCommandNamed: aCommandName message: nil! !

!JdmMysqlCommand class methodsFor: 'instance creation' stamp: ''!
withCommandNamed: aCommandName message: aMessage 
	^(self new)
		command: (self perform: aCommandName);
		message: aMessage! !

!JdmMysqlCommand methodsFor: 'accessing' stamp: ''!
command
	^command! !

!JdmMysqlCommand methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:55'!
command: aCommand
	command _ aCommand! !

!JdmMysqlCommand methodsFor: 'accessing' stamp: ''!
message
	^message! !

!JdmMysqlCommand methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
message: aMessage 
	message _ aMessage isNil ifTrue: [' '] ifFalse: [aMessage]! !

Object subclass: #JdmMysqlTestSupport
	instanceVariableNames: 'randomGenerators mysqlTypes mysqlValues enumSetValues'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Mysql-Tests'!

!JdmMysqlTestSupport class methodsFor: 'constants' stamp: 'alnr 5/27/2007 18:28'!
connectionSpec
	"change as necessary... or define similar to the following
	mysql> create database persistence
	mysql> grant all privileges on persistence.* to 'persistence'@'localhost' 
		identified by 'persistence';"
	^(JdmConnectionSpec new initialize  
			database: 'persistence';
			host: (NetNameResolver addressForName: 'localhost');
			port: 3306;
			user: 'persistence';
			password: 'persistence')
			
	"
	JdmConnection new connectionSpec: self connectionSpec;  initialize2
	"! !

!JdmMysqlTestSupport class methodsFor: 'singleton' stamp: ''!
mysqlTestSupport
	Instance isNil ifTrue: [Instance := self new initialize].
	^Instance! !

!JdmMysqlTestSupport class methodsFor: 'constants' stamp: 'cwp 8/21/2002 14:35'!
numRowsToInsert
	^ 20! !

!JdmMysqlTestSupport class methodsFor: 'singleton' stamp: 'cwp 8/23/2002 12:44'!
reset! !

!JdmMysqlTestSupport class methodsFor: 'constants' stamp: ''!
tableName
	^'JdmMysqlTestTable'! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: ''!
charValue
	^[:type :support | 'Z' ]! !

!JdmMysqlTestSupport methodsFor: 'private' stamp: ''!
createDelimitedStringFor: aCollection delimiter: aDelimiter using: aBlock 
	| collection writeStream |
	collection := aCollection asOrderedCollection.
	collection size = 0 ifTrue: [^''].
	writeStream := WriteStream on: String new.
	writeStream nextPutAll: (aBlock value: collection first).
	2 to: collection size
		do: 
			[:index | 
			writeStream
				nextPutAll: aDelimiter;
				nextPutAll: (aBlock value: (collection at: index))].
	^writeStream contents! !

!JdmMysqlTestSupport methodsFor: 'accessing' stamp: ''!
createTable
	^self createTableNamed: self class tableName! !

!JdmMysqlTestSupport methodsFor: 'accessing' stamp: ''!
createTableNamed: aName 
	| writeStream |
	writeStream := WriteStream on: String new.
	writeStream
		nextPutAll: 'CREATE TABLE ';
		nextPutAll: aName;
		nextPut: $(;
		cr.
	writeStream nextPutAll: (self 
				createDelimitedStringFor: mysqlTypes keys
				delimiter: ', '
				using: [:field | self getFieldDefinitionFor: field]).
	^writeStream
		nextPut: $);
		contents! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: 'cwp 8/21/2002 12:24'!
dateTimeValue
	^
	[:type :support | 
	TimeStamp date: (support dateValue value: #date value: support)
		time: (support timeValue value: #time value: support)]! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: ''!
dateValue
	^[:type :support | Date fromDays: (support nextRandomFor: type)]! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: 'cwp 8/22/2002 15:51'!
decimalValue
	^[:type :support | (support nextRandomFor: #smallInt) / 100]! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: 'cwp 8/20/2002 17:39'!
doubleValue
	^[:type :support | 1.7976931348623e308 ]! !

!JdmMysqlTestSupport methodsFor: 'private' stamp: ''!
enumSetValues
	^enumSetValues! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: ''!
enumValue
	^[:type :support | support enumSetValues at: (support nextRandomFor: type)]! !

!JdmMysqlTestSupport methodsFor: 'private' stamp: ''!
enumValues
	^self 
		createDelimitedStringFor: self enumSetValues
		delimiter: ', '
		using: [:enumValue | '''' , enumValue , '''']! !

!JdmMysqlTestSupport methodsFor: 'private' stamp: ''!
fieldNameFor: aType 
	^'Jdm' , aType! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: ''!
floatValue
	^[:type :support | 3.402823466e38 ]! !

!JdmMysqlTestSupport methodsFor: 'private' stamp: ''!
getFieldDefinitionFor: aType 
	| writeStream |
	writeStream := WriteStream on: String new.
	self writeFieldDefinitionFor: aType on: writeStream.
	^writeStream contents! !

!JdmMysqlTestSupport methodsFor: 'initialize-release' stamp: ''!
initialize
	randomGenerators := IdentityDictionary new.
	mysqlValues := IdentityDictionary new.
	enumSetValues := OrderedCollection new.
	mysqlTypes := IdentityDictionary new.
	self
		initializeEnumSetValues;
		initializeRandomGenerators;
		initializeMysqlValues;
		initializeMysqlTypes! !

!JdmMysqlTestSupport methodsFor: 'private-initialize' stamp: ''!
initializeEnumSetValues
	enumSetValues add: 'Apples'.
	enumSetValues add: 'Bananas'.
	enumSetValues add: 'Grapes'.
	enumSetValues add: 'Oranges'.
	enumSetValues add: 'Peaches'.! !

!JdmMysqlTestSupport methodsFor: 'private-initialize' stamp: ''!
initializeMysqlTypes
	mysqlTypes
		at: #tinyInt put: 'TINYINT';
		at: #tinyIntUnsigned put: 'TINYINT UNSIGNED';
		at: #tinyIntZerofill put: 'TINYINT ZEROFILL';
		at: #tinyIntUnsignedZerofill put: 'TINYINT UNSIGNED ZEROFILL';

		at: #smallInt put: 'SMALLINT';
		at: #smallIntUnsigned put: 'SMALLINT UNSIGNED';
		at: #smallIntZerofill put: 'SMALLINT ZEROFILL';
		at: #smallIntUnsignedZerofill put: 'SMALLINT UNSIGNED ZEROFILL';

		at: #mediumInt put: 'MEDIUMINT';
		at: #mediumIntUnsigned put: 'MEDIUMINT UNSIGNED';
		at: #mediumIntZerofill put: 'MEDIUMINT ZEROFILL';
		at: #mediumIntUnsignedZerofill put: 'MEDIUMINT UNSIGNED ZEROFILL';

		at: #int put: 'INT';
		at: #intUnsigned put: 'INT UNSIGNED';
		at: #intZerofill put: 'INT ZEROFILL';
		at: #intUnsignedZerofill put: 'INT UNSIGNED ZEROFILL';

		at: #bigInt put: 'BIGINT';
		at: #bigIntUnsigned put: 'BIGINT UNSIGNED';
		at: #bigIntZerofill put: 'BIGINT ZEROFILL';
		at: #bigIntUnsignedZerofill put: 'BIGINT UNSIGNED ZEROFILL';

		at: #float put: 'FLOAT(4)';
		at: #double put: 'FLOAT(8)';
		at: #decimal put: 'DECIMAL(10, 5)';
		at: #date put: 'DATE';
		at: #time put: 'TIME';
		at: #dateTime put: 'DATETIME';
		at: #timestamp put: 'TIMESTAMP';
		at: #char put: 'CHAR';
		at: #varChar put: 'VARCHAR(70)';
		at: #tinyBlob put: 'TINYBLOB';
		at: #blob put: 'BLOB';
		at: #mediumBlob put: 'MEDIUMBLOB';
		at: #longBlob put: 'LONGBLOB';
		at: #tinyText put: 'TINYTEXT';
		at: #text put: 'TEXT';
		at: #mediumText put: 'MEDIUMTEXT';
		at: #enum put: 'ENUM(', self enumValues, ')';		
		at: #set put: 'SET(', self enumValues, ')'! !

!JdmMysqlTestSupport methodsFor: 'private-initialize' stamp: 'cwp 8/22/2002 17:10'!
initializeMysqlValues
	mysqlValues
		at: #tinyInt put: #intValue;
		at: #tinyIntUnsigned put: #intValue;
		at: #tinyIntZerofill put: #intValue;
		at: #tinyIntUnsignedZerofill put: #intValue;

		at: #smallInt put: #intValue;
		at: #smallIntUnsigned put: #intValue;
		at: #smallIntZerofill put: #intValue;
		at: #smallIntUnsignedZerofill put: #intValue;

		at: #mediumInt put: #intValue;
		at: #mediumIntUnsigned put: #intValue;
		at: #mediumIntZerofill put: #intValue;
		at: #mediumIntUnsignedZerofill put: #intValue;

		at: #int put: #intValue;
		at: #intUnsigned put: #intValue;
		at: #intZerofill put: #intValue;
		at: #intUnsignedZerofill put: #intValue;

		at: #bigInt put: #intValue;
		at: #bigIntUnsigned put: #intValue;
		at: #bigIntZerofill put: #intValue;
		at: #bigIntUnsignedZerofill put: #intValue;

		at: #float put: #floatValue;
		at: #double put: #doubleValue;
		at: #decimal put: #decimalValue;
		at: #date put: #dateValue;
		at: #time put: #timeValue;
		at: #timestamp put: #timestampValue;
		at: #dateTime put: #dateTimeValue;
		at: #char put: #charValue;
		at: #varChar put: #stringValue;
		at: #tinyBlob put: #stringValue;
		at: #blob put: #stringValue;
		at: #mediumBlob put: #stringValue;
		at: #longBlob put: #stringValue;
		at: #tinyText put: #stringValue;
		at: #text put: #stringValue;
		at: #mediumText put: #stringValue;
		at: #enum put: #enumValue;		
		at: #set put: #setValue! !

!JdmMysqlTestSupport methodsFor: 'private-initialize' stamp: ''!
initializeRandomGenerators
	randomGenerators
		at: #tinyInt put: (JdmRangedRandom between: -128 and: 127);
		at: #tinyIntUnsigned put: (JdmRangedRandom between: 0 and: 255);
		at: #tinyIntZerofill put: (randomGenerators at: #tinyInt);
		at: #tinyIntUnsignedZerofill
			put: (randomGenerators at: #tinyIntUnsigned);

		at: #smallInt put: (JdmRangedRandom between: -32768 and: 32767);
		at: #smallIntUnsigned put: (JdmRangedRandom between: 0 and: 65535);
		at: #smallIntZerofill put: (randomGenerators at: #smallInt);
		at: #smallIntUnsignedZerofill put: (randomGenerators at: #smallIntUnsigned);

		at: #mediumInt put: (JdmRangedRandom between: -8388608 and: 8388607);
		at: #mediumIntUnsigned put: (JdmRangedRandom between: 0 and: 16777215);
		at: #mediumIntZerofill put: (randomGenerators at: #mediumInt);
		at: #mediumIntUnsignedZerofill put: (randomGenerators at: #mediumIntUnsigned);

		at: #int put: (JdmRangedRandom between: -2147483648 and: 2147483647);
		at: #intUnsigned put: (JdmRangedRandom between: 0 and: 4294967295);
		at: #intZerofill put: (randomGenerators at: #int);
		at: #intUnsignedZerofill put: (randomGenerators at: #intUnsigned);

		at: #bigInt put: (JdmRangedRandom between: -9223372036854775808 and: 9223372036854775807);
		at: #bigIntUnsigned put: (JdmRangedRandom between: 0 and:  18446744073709551615);
		at: #bigIntZerofill put: (randomGenerators at: #bigInt);
		at: #bigIntUnsignedZerofill put: (randomGenerators at: #bigIntUnsigned);

		at: #date put: (JdmRangedRandom between: -329083 and:  2958098);
		at: #time put: (JdmRangedRandom between: 0 and: 86399);
		at: #enum put: (JdmRangedRandom between: 1 and: 5);
		at: #set put: (randomGenerators at: #enum)! !

!JdmMysqlTestSupport methodsFor: 'accessing' stamp: ''!
insertIntoTable
	^self insertIntoTableNamed: self class tableName! !

!JdmMysqlTestSupport methodsFor: 'accessing' stamp: ''!
insertIntoTableNamed: aName 
	| writeStream |
	writeStream := WriteStream on: String new.
	writeStream
		nextPutAll: 'INSERT INTO ';
		nextPutAll: aName;
		nextPutAll: ' (';
		cr.
	writeStream nextPutAll: (self 
				createDelimitedStringFor: mysqlTypes keys
				delimiter: ', '
				using: [:field | self fieldNameFor: field]).
	writeStream
		nextPutAll: ') VALUES (';
		cr.
	writeStream
		nextPutAll: (self 
					createDelimitedStringFor: mysqlTypes keys
					delimiter: ', '
					using: 
						[:type | 
						| valueSelector |
						valueSelector := mysqlValues at: type ifAbsent: #null.
						JdmFieldConverter fieldConverter 
							convertToMysql: ((self perform: valueSelector) value: type value: self)]);
		nextPut: $).
	^writeStream contents! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: ''!
intValue
	^[:type :support | support nextRandomFor: type]! !

!JdmMysqlTestSupport methodsFor: 'private' stamp: ''!
nextRandomFor: aType
	^(randomGenerators at: aType) next! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: ''!
null
	^[:type :support | 'NULL' ]! !

!JdmMysqlTestSupport methodsFor: 'accessing' stamp: 'cwp 8/22/2002 16:09'!
randomValueForType: type
	| valueSelector |
	valueSelector := mysqlValues at: type ifAbsent: [#null].
	^ (self perform: valueSelector) value: type value: self! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: 'cwp 8/22/2002 17:12'!
setValue
	| size selected |
	^[:type :support | 
		size _ enumSetValues size atRandom.
		selected _ Set new: size.
		size timesRepeat:
			[selected add: 
				(support enumSetValues at: 
					(support nextRandomFor: #enum))].
			selected]! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: ''!
stringValue
	^[:type :support | 'This is a String with UPPER and lower CaSeS' ]! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: ''!
timeValue
	^[:type :support | Time fromSeconds: (support nextRandomFor: type)]! !

!JdmMysqlTestSupport methodsFor: 'private-values' stamp: 'cwp 8/20/2002 17:47'!
timestampValue
	^[:type :support | TimeStamp current]! !

!JdmMysqlTestSupport methodsFor: 'private' stamp: ''!
writeFieldDefinitionFor: aType on: aWriteStream 
	aWriteStream
		nextPutAll: (self fieldNameFor: aType);
		nextPut: $ ;
		nextPutAll: (mysqlTypes at: aType)! !

Object subclass: #JdmPacket
	instanceVariableNames: 'packetNumber size buffer stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

JdmPacket subclass: #JdmInputPacket
	instanceVariableNames: 'readStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmInputPacket methodsFor: 'reading' stamp: 'jb 3/2/1999 17:33'!
checkForStatus: anInteger onError: aSymbol 

	(self readStatusOnError: aSymbol) = anInteger ifFalse: [self handleError: aSymbol]! !

!JdmInputPacket methodsFor: 'reading' stamp: 'jb 3/2/1999 17:33'!
checkStatusOnError: aSymbol 
	
	self checkForStatus: 0 onError: aSymbol! !

!JdmInputPacket methodsFor: 'reading' stamp: 'bolot 12/16/1999 18:23'!
handleError: aSymbol 
	
	JdmErrorTable errorTable throwException: aSymbol
		message: ((readStream next: 2) asByteArray shortAt: 1 bigEndian: false) printString , ' ' 
				, readStream readNullTerminatedString! !

!JdmInputPacket methodsFor: 'initialize-release' stamp: 'alnr 9/6/2004 22:08'!
initialize2

	"Renamed, see JdmConnection>>#initialize2"
	
	size _ self readPacketSize.
	packetNumber _ self readPacketNumber.
	buffer _ self readBuffer.
	readStream _ JdmReadStream on: buffer.! !

!JdmInputPacket methodsFor: 'as yet unclassified' stamp: 'alnr 3/25/2007 18:07'!
isEOF

	^self size == 1
		and:[self readStream peek asInteger == 254]! !

!JdmInputPacket methodsFor: 'reading' stamp: 'jb 3/2/1999 17:32'!
readBuffer
	
	^self stream next: self size! !

!JdmInputPacket methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:56'!
readPacketNumber
	
	| ba o int1 |
	o _ (self stream next: self class packetNumberSize).
	ba _ o asByteArray.
	int1 _ ba basicAt: 1.
	^int1.

"	^(self stream next: self class packetNumberSize) asByteArray asInteger
"! !

!JdmInputPacket methodsFor: 'reading' stamp: 'cwp 8/22/2002 12:22'!
readPacketSize
	| ba o int1 int2 int3 |
	o _ self stream next: self class sizeSize.
	ba _ o asByteArray.
	int1 _ ba basicAt: 1.
	int2 _ ba basicAt: 2.
	int2 _ int2 bitShift: 8.
	int3 _ ba basicAt: 3.
	int3 _ int3 bitShift: 16.
	^int1 + int2 + int3.
! !

!JdmInputPacket methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:56'!
readStatusOnError: aSymbol
 
	| status |
	
	status _ readStream next asInteger.
	
	status = 255 ifFalse: [^status].
	
	self handleError: aSymbol! !

!JdmInputPacket methodsFor: 'accessing' stamp: 'jb 3/3/1999 18:20'!
readStream
	
	
	^readStream! !

JdmInputPacket subclass: #JdmLargeSizeInputPacket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmLargeSizeInputPacket methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:56'!
initialize
	size _ self readPacketSize.
	packetNumber _ self readPacketNumber.
	buffer _ self readBuffer.
	readStream _ JdmLargeSizeReadStream on: buffer! !

JdmPacket subclass: #JdmOutputPacket
	instanceVariableNames: 'writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmOutputPacket methodsFor: 'actions' stamp: 'bolot 12/16/1999 17:51'!
flush
	| aString ba s bytesSend |
	aString _ self writeStream contents.
	self writeStream close.
	self size: aString size - self class headerSize.
	ba _ JdmConnection integerAsByteArray: self size length: self class sizeSize.
	s _ JdmConnection byteArrayAsByteString: ba.
	aString replaceFrom: 1 to: self class sizeSize with: s startingAt: 1.

"	aString 
replaceFrom: 1
 to: self class sizeSize
	with: (self size asByteArray: self class sizeSize) asByteString
 startingAt: 1.

"	
	aString at: self class sizeSize + 1 put: self packetNumber asCharacter.
	

	(self stream) nextPutAll: aString; flush

"
	bytesSend _ socket sendData: aString.
	(bytesSend = aString size) ifFalse: [self error: 'error'.].
"
! !

!JdmOutputPacket methodsFor: 'initialize-release' stamp: 'alnr 9/6/2004 22:08'!
initialize2

	"Renamed, see JdmConnection>>#initialize2"
	packetNumber _ 0.
	buffer _ String new: self class defaultBufferSize.
	writeStream _ JdmWriteStream on: buffer startingAt: (self class headerSize) outputPacket: (self).
	"This is a bit of a hack...I should utilize events instead"
	
"	writeStream expressInterestIn: #flush for: self sendBack: #flush"! !

!JdmOutputPacket methodsFor: 'accessing' stamp: 'bolot 12/16/1999 17:51'!
writeStream
	^writeStream! !

!JdmPacket class methodsFor: 'constants' stamp: ''!
defaultBufferSize
	^8192! !

!JdmPacket class methodsFor: 'constants' stamp: ''!
headerSize
	^4! !

!JdmPacket class methodsFor: 'instance creation' stamp: 'alnr 9/6/2004 22:08'!
on: aStream 
	^(self new) stream: aStream; initialize2! !

!JdmPacket class methodsFor: 'constants' stamp: ''!
packetNumberOffset
	^4! !

!JdmPacket class methodsFor: 'constants' stamp: ''!
packetNumberSize
	^1! !

!JdmPacket class methodsFor: 'constants' stamp: ''!
sizeOffset
	^1! !

!JdmPacket class methodsFor: 'constants' stamp: ''!
sizeSize
	^3! !

!JdmPacket methodsFor: 'accessing' stamp: ''!
packetNumber
	^packetNumber! !

!JdmPacket methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
packetNumber: anInteger
	packetNumber _ anInteger! !

!JdmPacket methodsFor: 'accessing' stamp: ''!
size
	^size! !

!JdmPacket methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
size: anObject
	size _ anObject! !

!JdmPacket methodsFor: 'accessing' stamp: ''!
stream
	^stream! !

!JdmPacket methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
stream: anObject
	stream _ anObject! !

Object subclass: #JdmRangedRandom
	instanceVariableNames: 'random highValue lowValue range numRandomBits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Tests'!

!JdmRangedRandom class methodsFor: 'instance creation' stamp: ''!
between: anInteger and: anInteger2
	^self new between: anInteger and: anInteger2! !

!JdmRangedRandom class methodsFor: 'constants' stamp: ''!
randomBits
	^16! !

!JdmRangedRandom class methodsFor: 'constants' stamp: ''!
randomFactor
	^1000000! !

!JdmRangedRandom class methodsFor: 'constants' stamp: ''!
randomMask
	^16rFFFF! !

!JdmRangedRandom methodsFor: 'initialize' stamp: ''!
between: anInteger and: anInteger2 
	random := Random new.
	highValue := anInteger max: anInteger2.
	lowValue := anInteger min: anInteger2.
	range := highValue - lowValue.
	range > 0 ifTrue: [range := range + 1].
	numRandomBits := self randomBitsNeededFor: range! !

!JdmRangedRandom methodsFor: 'private' stamp: ''!
maskFor: numBits 
	^(self class randomMask bitShift: numBits - self class randomBits) 
		bitAnd: self class randomMask! !

!JdmRangedRandom methodsFor: 'accessing' stamp: ''!
next
	| aRandom |
	aRandom := self nextRandom \\ range.
	aRandom = 0 ifTrue: [(self rangeIncludes: 0) ifFalse: [^self next]].
	^lowValue + aRandom! !

!JdmRangedRandom methodsFor: 'private' stamp: 'cwp 8/22/2002 15:12'!
nextRandom
	| nextRandom numBits numBitsToUse |
	nextRandom := 0.
	numBits := numRandomBits.
	[numBits = 0] whileFalse: 
			[numBitsToUse := numBits min: self class randomBits.
			nextRandom := (nextRandom bitShift: numBitsToUse) 
						bitOr: ((random next * self class randomFactor) asInteger 
								bitAnd: (self maskFor: numBitsToUse)).
			numBits := numBits - numBitsToUse].
	^nextRandom! !

!JdmRangedRandom methodsFor: 'private' stamp: 'cwp 8/20/2002 15:38'!
randomBitsNeededFor: anInteger 
	| numBits |
	numBits := (anInteger log: 2) ceiling.
	(2 raisedTo: numBits) < anInteger ifTrue: [numBits := numBits + 1].
	^numBits! !

!JdmRangedRandom methodsFor: 'private' stamp: ''!
rangeIncludes: aValue
	^(highValue >= aValue and: [lowValue <= aValue])! !

Object subclass: #JdmResult
	instanceVariableNames: 'value type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmResult methodsFor: 'testing' stamp: ''!
hasResultSet
	^type = #read! !

!JdmResult methodsFor: 'accessing' stamp: ''!
type
	^type! !

!JdmResult methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
type: aType
	type _ aType! !

!JdmResult methodsFor: 'accessing' stamp: ''!
value
	^value! !

!JdmResult methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
value: aValue
	value _ aValue! !

Object subclass: #JdmResultSet
	instanceVariableNames: 'columns connection columnsByName currentRow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmResultSet class methodsFor: 'instance creation' stamp: 'alnr 9/6/2004 22:08'!
on: aConnection 
	^(self new)
		connection: aConnection;
		initialize2! !

!JdmResultSet methodsFor: 'as yet unclassified' stamp: 'ajr 8/2/2003 17:25'!
collect: aBlock

	| answer |
	answer := OrderedCollection new .
	[self next] whileTrue:[
		answer add: (aBlock value: self currentRowAsDictionary)] .
	^answer! !

!JdmResultSet methodsFor: 'accessing' stamp: ''!
columnAt: index
	^columns at: index! !

!JdmResultSet methodsFor: 'accessing' stamp: ''!
columnNamed: aName 
	^self columnAt: (columnsByName at: aName ifAbsent: [^nil])! !

!JdmResultSet methodsFor: 'accessing' stamp: ''!
columns
	^columns! !

!JdmResultSet methodsFor: 'accessing' stamp: ''!
connection
	^connection! !

!JdmResultSet methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:54'!
connection: anObject
	connection _ anObject! !

!JdmResultSet methodsFor: 'private-accessing' stamp: ''!
currentRow
	^currentRow! !

!JdmResultSet methodsFor: 'accessing' stamp: 'ajr 8/2/2003 17:20'!
currentRowAsDictionary

	| answer |
	answer := Dictionary new .
	columnsByName keys do: [ : key  |
		answer at: key put:
			(self valueNamed: key)].
	^answer
	"
	self currentRowAsDictionary
	"
! !

!JdmResultSet methodsFor: 'as yet unclassified' stamp: 'wh 8/15/2006 13:32'!
currentRowAsRawDictionary

	| answer |
	answer := Dictionary new .
	columnsByName keys do: [ : key  |
		answer at: key put:
			(self rawValueNamed: key)].
	^answer
! !

!JdmResultSet methodsFor: 'as yet unclassified' stamp: 'wh 11/28/2005 10:27'!
flush
	self hasNext ifFalse: [^self].
	[self next] whileTrue: []! !

!JdmResultSet methodsFor: 'as yet unclassified' stamp: 'wh 11/28/2005 10:27'!
hasNext
	^self currentRow isEmpty not! !

!JdmResultSet methodsFor: 'initialize-release' stamp: 'alnr 9/6/2004 22:08'!
initialize2
			
	"Renamed, see JdmConnection>>#initialize2"

	| column rpacket |
	
	columnsByName _ Dictionary new.
	rpacket _ connection responsePacket.
	columns _ Array new: (rpacket readStatusOnError: #invalidQuery).
	1 to: columns size do: [:index | 
		rpacket _ connection responsePacket.	
		column _ JdmColumn readFrom: rpacket readStream.
		columns at: index put: column.
		columnsByName at: column name put: index].
	connection responsePacket checkForStatus: 254 onError: #invalidQuery.
	currentRow _ JdmRow withNumColumns: columns size.! !

!JdmResultSet methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:54'!
next
	currentRow _ (JdmRow withNumColumns: columns size) 
				readFrom: connection responsePacket readStream.
	^currentRow isEmpty not! !

!JdmResultSet methodsFor: 'accessing' stamp: 'alnr 9/6/2004 22:08'!
nextAsDictionary

	self next ifFalse:[^nil].
	^self currentRowAsDictionary! !

!JdmResultSet methodsFor: 'as yet unclassified' stamp: 'ajr 8/2/2003 17:15'!
nextRow

	self next ifFalse:[^nil].
	^self currentRowAsDictionary! !

!JdmResultSet methodsFor: 'accessing' stamp: ''!
rawValueAt: anIndex
	^self currentRow at: anIndex! !

!JdmResultSet methodsFor: 'accessing' stamp: ''!
rawValueNamed: aName 
	^self rawValueAt: (columnsByName at: aName)! !

!JdmResultSet methodsFor: 'accessing' stamp: 'alnr 3/17/2007 23:47'!
serverVersion

	^self connection serverVersion! !

!JdmResultSet methodsFor: 'accessing' stamp: ''!
valueAt: anIndex 
	^JdmFieldConverter fieldConverter convert: (self currentRow at: anIndex)
		from: (self columns at: anIndex)! !

!JdmResultSet methodsFor: 'accessing' stamp: ''!
valueNamed: aName 
	^self valueAt: (columnsByName at: aName)! !

Object subclass: #JdmRow
	instanceVariableNames: 'numColumns values isEmpty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmRow class methodsFor: 'instance creation' stamp: 'alnr 9/6/2004 22:08'!
withNumColumns: anInteger 
	^(self new)
		numColumns: anInteger;
		initialize2! !

!JdmRow methodsFor: 'accessing' stamp: ''!
at: anIndex
	^values at: anIndex! !

!JdmRow methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:54'!
checkForEndOrNull: aReadStream 
	"This is a bit unclean...the value 254 has been overloaded in the protocol.  When it is the only
        value in the stream, it indicates there are no more rows.  It also indicates that the following
        4 bytes contain the size of the field value.  The problem is that there is another condition that
        produces a single value on the stream...a row with one column whose value is NULL."

	| endOrNull |
	aReadStream size = 1 ifFalse: [^false].
	endOrNull _ aReadStream next asInteger.
	endOrNull = 254 
		ifTrue: 
			[isEmpty _ true.
			^true].
	endOrNull = 251 ifTrue: [^true].
	"Unexpected Value"
	JdmErrorTable throwException: #invalidQuery
		message: 'Unexpected value ' , endOrNull printString.
	^true! !

!JdmRow methodsFor: 'initialize-release' stamp: 'alnr 9/6/2004 22:08'!
initialize2

 	"Renamed, see JdmConnection>>#initialize2"
	values _ Array new: numColumns.
	self initializeWithNulls.
	isEmpty _ false.! !

!JdmRow methodsFor: 'initialize-release' stamp: ''!
initializeWithNulls
	1 to: numColumns do: [:index | values at: index put: nil]! !

!JdmRow methodsFor: 'testing' stamp: ''!
isEmpty
	^isEmpty! !

!JdmRow methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:54'!
numColumns: anInteger
	numColumns _ anInteger! !

!JdmRow methodsFor: 'reading' stamp: ''!
readFrom: aReadStream 
	(self checkForEndOrNull: aReadStream) ifTrue: [^self].
	self readRowsFrom: aReadStream! !

!JdmRow methodsFor: 'reading' stamp: 'cwp 8/21/2002 23:07'!
readRowsFrom: aReadStream 
	| aSize |
	1 to: numColumns do: 
			[:index | 
			aSize _ aReadStream readSize32.
			aSize = 0 ifFalse: [values at: index put: (aReadStream next: aSize)]]! !

Object subclass: #JdmServerInfo
	instanceVariableNames: 'protocol serverVersion serverThread hashSeed options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmServerInfo class methodsFor: 'constants' stamp: ''!
clientProtocolSize
	^1! !

!JdmServerInfo class methodsFor: 'instance creation' stamp: 'jb 3/2/1999 17:26'!
on: aConnection 
	
	^self new readFrom: aConnection responsePacket! !

!JdmServerInfo class methodsFor: 'constants' stamp: ''!
optionsSize
	^2! !

!JdmServerInfo class methodsFor: 'constants' stamp: ''!
serverThreadSize
	^4! !

!JdmServerInfo methodsFor: 'accessing' stamp: ''!
hashSeed
	^hashSeed! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
hashSeed: anObject
	hashSeed _ anObject! !

!JdmServerInfo methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:51'!
initialize
	serverVersion _ JdmServerVersion new initialize.
	hashSeed _ String new.
	protocol _ -1.
	serverThread _ -1.
	options _ -1! !

!JdmServerInfo methodsFor: 'accessing' stamp: ''!
options
	^options! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
options: anObject
	options _ anObject! !

!JdmServerInfo methodsFor: 'accessing' stamp: ''!
protocol
	^protocol! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
protocol: aProtocol 
	self validateProtocol: aProtocol.
	protocol _ aProtocol! !

!JdmServerInfo methodsFor: 'reading' stamp: 'alnr 3/11/2007 18:02'!
read: count from: aResponsePacket

	^(aResponsePacket readStream next: count) asByteArray! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:52'!
readFrom: aResponsePacket
	self
		readProtocolFrom: aResponsePacket;
		readServerVersionFrom: aResponsePacket;
		readServerThreadFrom: aResponsePacket;
		readHashSeedFrom: aResponsePacket;
		readOptionsFrom: aResponsePacket! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:53'!
readHashSeedFrom: aResponsePacket
	hashSeed _ aResponsePacket readStream readNullTerminatedString! !

!JdmServerInfo methodsFor: 'reading' stamp: 'alnr 3/11/2007 18:24'!
readMoreSaltFrom: aResponsePacket

	| hashSeed2 |
	(options bitAnd: 32768) == 0 ifTrue:[^nil]. "32768=new 4.1 auth"
	hashSeed2 := aResponsePacket readStream readNullTerminatedString .
	hashSeed := hashSeed , hashSeed2 .
	^hashSeed2! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:52'!
readOptionsFrom: aResponsePacket 
	| ba int1 int2 |
	ba _ (aResponsePacket readStream next: 2) asByteArray .
	int1 _ ba basicAt: 1.
	int2 _ ba basicAt: 2.
	int2 _ int2 bitShift: 8.
	options _ int1 + int2.

! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:52'!
readProtocolFrom: aResponsePacket 
	protocol _ (aResponsePacket readStatusOnError: #protocol)! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:53'!
readServerThreadFrom: aResponsePacket
	| ba int1 int2 int3 int4 |
	ba _ (aResponsePacket readStream next: 4) asByteArray .
	int1 _ ba basicAt: 1.
	int2 _ ba basicAt: 2.
	int2 _ int2 bitShift: 8.
	int3 _ ba basicAt: 3.
	int3 _ int3 bitShift: 16.
	int4 _ ba basicAt: 4.
	int4 _ int4 bitShift: 24.

	serverThread _ int1 + int2 + int3 + int4! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:53'!
readServerVersionFrom: aResponsePacket 
	serverVersion _ JdmServerVersion readFrom: aResponsePacket readStream! !

!JdmServerInfo methodsFor: 'accessing' stamp: ''!
serverThread
	^serverThread! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
serverThread: anObject
	serverThread _ anObject! !

!JdmServerInfo methodsFor: 'accessing' stamp: ''!
serverVersion
	^serverVersion! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
serverVersion: anObject
	serverVersion _ anObject! !

!JdmServerInfo methodsFor: 'validation' stamp: ''!
validateProtocol: aProtocol 
	(aProtocol = 9 or: [aProtocol = 10]) 
		ifFalse: [JdmErrorTable errorTable error: #protocol]! !

Object subclass: #JdmStatement
	instanceVariableNames: 'connection'
	classVariableNames: 'MysqlQueries'
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmStatement class methodsFor: 'private-parsing' stamp: 'jb 2/28/1999 18:23'!
getCommand: aQuery 
	
	| readStream writeStream aCharacter |
	
	writeStream := WriteStream on: String new.
	
	readStream := ReadStream on: aQuery.
	
	readStream skipSeparators.
	
	[readStream atEnd or: [aCharacter := readStream next. aCharacter isSeparator]] 
		
		whileFalse: [writeStream nextPut: aCharacter asUppercase].
	
	^writeStream contents! !

!JdmStatement class methodsFor: 'initialize-release' stamp: 'jb 2/28/1999 18:25'!
initialize
	
	"JdmStatement initialize"

	
	MysqlQueries := Dictionary new.
	
	self mysqlQueries do: 
			
		[:association | 
			
			MysqlQueries 
add: (Association key: (association at: 1) value: (association at: 2))]! !

!JdmStatement class methodsFor: 'initialize-release' stamp: 'jb 2/28/1999 18:25'!
initializeOnLoad
	
	self initialize! !

!JdmStatement class methodsFor: 'constants' stamp: 'tkow 3/5/2009 19:41'!
mysqlQueries
	
	"To be added: DESCRIBE, EXPLAIN, SHOW"
	
	^#( #('SELECT'    #(#read #JdmResultSet))
           	#('SHOW'	 #(#read #JdmResultSet))
			
		#('START'	 #(#update))

		#('COMMIT'	 #(#update))
			
		#('ROLLBACK' #(#update)) 	

		#('INSERT'     #(#insert))
           
		#('UPDATE'    #(#update))
           
		#('DELETE'      #(#update))
           
		#('CREATE'    #(#update))
           
		#('DROP'       #(#update))
		
		#('TRUNCATE' #(#update))
           
		#('ALTER'      #(#update ))
           
		#('LOCK'       #(#update ))
           
		#('UNLOCK'   #(#update ))
           
		#('SET'          #(#update ))
           
		#('GRANT'     #(#update ))
           
		#('REPLACE'  #(#update )))! !

!JdmStatement class methodsFor: 'instance creation' stamp: 'jb 2/28/1999 18:25'!
on: aConnection 
	
	^self new connection: aConnection! !

!JdmStatement class methodsFor: 'accessing' stamp: 'jb 2/28/1999 18:22'!
queryInfoFor: aQuery 
	
	^MysqlQueries at: (self getCommand: aQuery) ifAbsent: [nil]! !

!JdmStatement methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:49'!
connection: aConnection
	connection _ aConnection! !

!JdmStatement methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:49'!
createResult: queryInfo 
	^self perform: ((queryInfo at: 1) , 'Result:') asSymbol with: queryInfo! !

!JdmStatement methodsFor: 'accessing' stamp: 'wh 12/12/2005 14:37'!
executeQuery: aQuery 
	| queryInfo r |
	queryInfo _ self class queryInfoFor: aQuery.
	queryInfo isNil 
		ifTrue: 
		[JdmErrorTable errorTable throwException: #invalidQuery message: aQuery].
	(connection requestPacket writeStream)
 	nextPutCommand:
		(JdmMysqlCommand withCommandNamed: #query message: aQuery);
	flush.
	r _ self createResult: queryInfo.
	^r! !

!JdmStatement methodsFor: 'private-accessing' stamp: 'cwp 8/17/2002 00:29'!
insertResult: queryInfo 
	"Save the insert id"
	| responsePacket affectedRows insertID |
	responsePacket _ connection responsePacket.
	responsePacket checkStatusOnError: #invalidQuery.
	affectedRows _ responsePacket readStream readSize.
	insertID _ responsePacket readStream readSize.
	^(JdmResult new) type: (queryInfo at: 1); value: insertID! !

!JdmStatement methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:49'!
readResult: queryInfo 
	| symbol aClass |
	symbol _ (JdmResult new) type: (queryInfo at: 1); value: ((queryInfo at: 2)).
	aClass _ JdmConnection symbolAsClass: (queryInfo at: 2) asSymbol.
     ^aClass on: connection.

"	^(JdmResult new)
 type: (queryInfo at: 1);
 value: ((queryInfo at: 2) inspect)."! !

!JdmStatement methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:50'!
updateResult: queryInfo 
	"Right now the insert id is being dropped."
	| responsePacket affectedRows insertID |
	responsePacket _ connection responsePacket.
	responsePacket checkStatusOnError: #invalidQuery.
	affectedRows _ responsePacket readStream readSize.
	insertID _ responsePacket readStream readSize.
	^(JdmResult new) type: (queryInfo at: 1); value: affectedRows! !

Object subclass: #JdmTimeHolder
	instanceVariableNames: 'time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmTimeHolder class methodsFor: 'instance creation' stamp: 'bolot 2/10/2000 08:32'!
readFrom: aStream 
	^self new
		value: (JdmTimestampPrintPolicy timestampPrintPolicy reader 
				readMysqlTimeFrom: aStream)! !

!JdmTimeHolder methodsFor: 'initialize-release' stamp: ''!
initialize
	time := Time now! !

!JdmTimeHolder methodsFor: 'printing' stamp: 'bolot 2/10/2000 08:43'!
printOn: aStream 
	| aPolicy tokens |
	(aStream respondsTo: #policy)
		ifTrue:
			[aPolicy := aStream policy dateAndTimePolicy.
			tokens := JdmTimestampPrintPolicy timestampPrintPolicy policyNamed: #JdmTime.
			aPolicy
				print: time
				on: aStream
				policy: tokens]
		ifFalse:
			[time print24: true on: aStream]! !

!JdmTimeHolder methodsFor: 'accessing' stamp: ''!
value
	^time! !

!JdmTimeHolder methodsFor: 'accessing' stamp: ''!
value: aTime
	time := aTime! !

Object subclass: #JdmTimestampHolder
	instanceVariableNames: 'timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmTimestampHolder class methodsFor: 'instance creation' stamp: 'bolot 2/10/2000 08:51'!
readFrom: aStream 
	^self new
		value: (JdmTimestampPrintPolicy timestampPrintPolicy reader 
				readMysqlTimestampFrom: aStream)! !

!JdmTimestampHolder methodsFor: 'initialize-release' stamp: 'bolot 1/28/2001 23:21'!
initialize
	timestamp := TimeStamp current! !

!JdmTimestampHolder methodsFor: 'printing' stamp: 'bolot 2/10/2000 08:43'!
printOn: aStream 
	| aPolicy tokens |
	(aStream respondsTo: #policy)
		ifTrue:
			[aPolicy := aStream policy dateAndTimePolicy.
			tokens := JdmTimestampPrintPolicy timestampPrintPolicy 
						policyNamed: #JdmTimestamp.
			aPolicy 
				print: timestamp
				on: aStream
				policy: tokens]
		ifFalse:
			[timestamp printOn: aStream]! !

!JdmTimestampHolder methodsFor: 'accessing' stamp: ''!
value
	^timestamp! !

!JdmTimestampHolder methodsFor: 'accessing' stamp: ''!
value: aTimestamp
	timestamp := aTimestamp! !

Object subclass: #JdmTimestampPrintPolicy
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmTimestampPrintPolicy class methodsFor: 'singleton' stamp: 'bolot 2/10/2000 08:26'!
newFor: nameSpace
	^self new! !

!JdmTimestampPrintPolicy class methodsFor: 'singleton' stamp: ''!
resetTimestampPrintPolicy
	Instance := nil! !

!JdmTimestampPrintPolicy class methodsFor: 'singleton' stamp: ''!
timestampPrintPolicy
	Instance isNil ifTrue: [Instance := self newFor: #mysql].
	^Instance! !

!JdmTimestampPrintPolicy methodsFor: 'initialize-release' stamp: ''!
mysql
	self
		us;
		policyNamed: #JdmTimestamp putString: 'yyyymmddhhmmss';
		policyNamed: #JdmTime putString: 'hh:mm:ss';
		policyNamed: #JdmDate putString: 'yyyy-mm-dd'! !

!JdmTimestampPrintPolicy methodsFor: 'accessing' stamp: ''!
reader
	^(JdmTimestampReader newFor: localeID)
		printPolicy: self;
		yourself! !

Object subclass: #JdmTimestampReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmTimestampReader class methodsFor: 'instance creation' stamp: 'bolot 2/10/2000 08:26'!
newFor: nameSpace
	^self new! !

!JdmTimestampReader methodsFor: 'initialize' stamp: ''!
mysql
	timeSelector := #readMysqlTimeFrom:.
	dateSelector := #readMysqlDateFrom:.
	timestampSelector := #readMysqlTimestampFrom:! !

!JdmTimestampReader methodsFor: 'bad should fix' stamp: 'bolot 2/10/2000 08:28'!
printPolicy: aPolicy
	"ignore"! !

!JdmTimestampReader methodsFor: 'private-reading' stamp: ''!
readIntegerFrom: aStream next: anInteger 
	^Integer readFrom: (ReadStream on: (aStream next: anInteger))! !

!JdmTimestampReader methodsFor: 'reading mysql' stamp: 'cwp 8/21/2002 22:12'!
readMysqlDateFrom: aStream 
	| day month year |
	year := Integer readFrom: aStream.
	year = 0 ifTrue: [^ nil].

	aStream next.
	month := Integer readFrom: aStream.
	month = 0 ifTrue: [^ nil].

	aStream next.
	day := Integer readFrom: aStream.
	day = 0 ifTrue: [^ nil].

	^ Date 
		newDay: day
		month: month
		year: year! !

!JdmTimestampReader methodsFor: 'reading mysql' stamp: 'cwp 8/21/2002 16:34'!
readMysqlDateTimeFrom: aStream 
	| date time |
	date _ self readMysqlDateFrom: aStream.
	aStream next.
	time _ self readMysqlTimeFrom: aStream.
	^ TimeStamp date: date time: time.! !

!JdmTimestampReader methodsFor: 'reading mysql' stamp: ''!
readMysqlTimeFrom: aStream 
	| hour minute second |
	hour := Integer readFrom: aStream.
	aStream next.
	minute := Integer readFrom: aStream.
	aStream next.
	second := Integer readFrom: aStream.
	^Time fromSeconds: 60 * (60 * hour + minute) + second! !

!JdmTimestampReader methodsFor: 'reading mysql' stamp: 'bolot 1/28/2001 23:28'!
readMysqlTimestampFrom: aStream 
	| year month day hour minute second |
	year := self readIntegerFrom: aStream next: 4.
	month := self readIntegerFrom: aStream next: 2.
	day := self readIntegerFrom: aStream next: 2.
	hour := self readIntegerFrom: aStream next: 2.
	minute := self readIntegerFrom: aStream next: 2.
	second := self readIntegerFrom: aStream next: 2.
	^TimeStamp
		date: (Date newDay: day month: month year: year)
		time: (Time fromSeconds: (3600 * hour) + (60 * minute) + second)! !

Magnitude subclass: #JdmServerVersion
	instanceVariableNames: 'fileFormat release version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmServerVersion class methodsFor: 'instance creation' stamp: ''!
readFrom: aStream 
	^self new readFrom: aStream! !

!JdmServerVersion methodsFor: 'comparing' stamp: ''!
< aJdmServerVersion 
	^aJdmServerVersion fileFormat > fileFormat or: 
			[(aJdmServerVersion fileFormat = fileFormat 
				and: [aJdmServerVersion serverRelease > release]) or: 
						[aJdmServerVersion serverRelease = release 
							and: [aJdmServerVersion version > version]]]! !

!JdmServerVersion methodsFor: 'comparing' stamp: ''!
= aJdmServerVersion 
	^fileFormat = aJdmServerVersion fileFormat and: 
			[release = aJdmServerVersion serverRelease 
				and: [version = aJdmServerVersion version]]! !

!JdmServerVersion methodsFor: 'accessing' stamp: ''!
fileFormat
	^fileFormat! !

!JdmServerVersion methodsFor: 'accessing' stamp: ''!
fileFormat: anInteger
	fileFormat := anInteger! !

!JdmServerVersion methodsFor: 'initialize-release' stamp: ''!
initialize
	fileFormat := 0.
	release := 0.
	version := 0.! !

!JdmServerVersion methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: fileFormat printString;
		nextPut: $.;
		nextPutAll: release printString;
		nextPut: $.;
		nextPutAll: version printString! !

!JdmServerVersion methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:51'!
readFrom: aStream
	fileFormat _ Integer readFrom: aStream.
	aStream next.
	release _ Integer readFrom: aStream.
	aStream next.
	version _ Integer readFrom: aStream.
	aStream readNullTerminatedString! !

!JdmServerVersion methodsFor: 'accessing' stamp: ''!
serverRelease
	"Renamed this because of a conflict with the Object method release"
	^release! !

!JdmServerVersion methodsFor: 'accessing' stamp: ''!
serverRelease: anInteger
	release := anInteger! !

!JdmServerVersion methodsFor: 'accessing' stamp: ''!
version
	^version! !

!JdmServerVersion methodsFor: 'accessing' stamp: ''!
version: anInteger
	version := anInteger! !

ReadStream subclass: #JdmLargeSizeReadStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmLargeSizeReadStream methodsFor: 'accessing' stamp: ''!
readSize
	^self readSize64! !

ReadStream subclass: #JdmReadStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmReadStream class methodsFor: 'constants' stamp: ''!
null
	^0! !

!JdmReadStream methodsFor: 'accessing' stamp: 'alnr 9/6/2004 22:08'!
readNullTerminatedString
	
	^self  upTo: self class null asCharacter! !

!JdmReadStream methodsFor: 'accessing' stamp: 'jb 3/2/1999 17:33'!
readSize
	
	^self readSize32! !

!JdmReadStream methodsFor: 'accessing' stamp: 'cwp 8/19/2002 23:49'!
readSize32
	
	| aSize result |
	
	aSize _ self next asInteger.
	
	(aSize < 0 or: [aSize > 254]) 
		
		ifTrue: 
	
		[JdmErrorTable throwException: #invalidSize message: aSize printString].
	
	aSize < 251 ifTrue: [^aSize].
	
	aSize = 251 ifTrue: [^0].
	
	aSize _	(aSize bitAnd: 3) + 2.
	result _ ByteArray with: 0 with: 0 with: 0 with: 0.
	self next: aSize into: result startingAt: 1.
	^ result unsignedLongAt: 1 bigEndian: false

! !

!JdmReadStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
readSize64
	
	| aSize |
	
	aSize _ self next asInteger.
	
	(aSize < 0 or: [aSize > 254]) 
		
		ifTrue: 
			
		[JdmErrorTable throwException: #invalidSize message: aSize printString].
	
	aSize < 251 ifTrue: [^aSize].
	
	aSize = 251 ifTrue: [^0].
	
	aSize < 254 
		
		ifTrue: [^(self next: (aSize bitAnd: 3) + 2) asByteArray asInteger].
	
	^(self next: 8) asByteArray asInteger! !

WriteStream subclass: #JdmWriteStream
	instanceVariableNames: 'outputPacket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmWriteStream class methodsFor: 'constants' stamp: ''!
null
	^0! !

!JdmWriteStream class methodsFor: 'instance creation' stamp: 'jb 3/2/1999 20:40'!
on: aCollection startingAt: aPosition 
outputPacket: op
	| ws |
	ws := (self
		on: aCollection)
		setWritePosition: aPosition.
	ws outputPacket: op.
	^ws! !

!JdmWriteStream class methodsFor: 'instance creation' stamp: 'jb 3/2/1999 20:40'!
xon: aCollection
 outputPacket: op
	| ws |
	ws := (super on: aCollection) initialize.
	ws outputPacket: op.
	^ws! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
close
"	super close.
	self breakDependents"! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
flush
"	super flush."
	self outputPacket flush! !

!JdmWriteStream methodsFor: 'initialize' stamp: ''!
initialize! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
nextPutAllNullTerminated: aCollection2 
	self nextPutAll: aCollection2.
	self nextPut: self class null asCharacter! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
nextPutCommand: aCommand 
	self
		nextPut: aCommand command asCharacter;
		nextPutAllNullTerminated: aCommand message! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'jb 3/2/1999 20:37'!
outputPacket
	^outputPacket! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
outputPacket: p
	outputPacket _ p! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:48'!
setWritePosition: aPosition 
	position _ (aPosition > writeLimit 
		ifTrue: [writeLimit]
		ifFalse: [aPosition])! !

TestCase subclass: #JdmTestDatabaseOperations
	instanceVariableNames: 'connection testSupport testProgress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Tests'!

!JdmTestDatabaseOperations methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2002 13:58'!
setUp
	super setUp.
	connection := JdmConnection on: 
		(JdmConnectionSpec new initialize
			database: 'TNTest';
			host: (NetNameResolver addressForName: 'trillian.whistler.com');
			user: 'tantalus';
			password: 'demo').
	testSupport := JdmMysqlTestSupport mysqlTestSupport.
! !

!JdmTestDatabaseOperations methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2002 13:58'!
tearDown
	connection close.! !

!JdmTestDatabaseOperations methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2002 14:22'!
testCreateTable
	| result |
	result := connection createStatement 
		executeQuery: testSupport createTable.
	self assert: result type = #update.
	self assert: result value = 0.! !

!JdmTestDatabaseOperations methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2002 14:17'!
testDropTable
	| result |
	result := connection createStatement 
				executeQuery: 'drop table ' , testSupport class tableName.
	self assert: result type = #update.
	self assert: result value = 0.
	! !

TestCase subclass: #JdmTestFieldConverter
	instanceVariableNames: 'support typeMap converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Tests'!

!JdmTestFieldConverter methodsFor: 'Running' stamp: 'cwp 8/22/2002 16:29'!
buildTypeMap
	typeMap _ Dictionary new: 20.
	typeMap
		at: JdmColumn tinyType 
		put: #(#tinyInt #tinyIntUnsigned #tinyIntZerofill #tinyIntUnsignedZerofill);
		
		at: JdmColumn shortType
		put: #(#smallInt #smallIntUnsigned #smallIntZerofill #smallIntUnsignedZerofill);

		at: JdmColumn int24Type 
		put: #(#mediumInt #mediumIntUnsigned #mediumIntZerofill #mediumIntUnsignedZerofill);
		
		at: JdmColumn longType
		put: #(#int #intUnsigned #intZerofill #intUnsignedZerofill);
		
		at: JdmColumn longlongType
		put: #(#bigInt #bigIntUnsigned #bigIntZerofill #bigIntUnsignedZerofill);

		at: JdmColumn varStringType 
		put: #(#char #varChar #tinyText #text #mediumText);

		at: JdmColumn stringType 
		put: #(#char #varChar #tinyText #text #mediumText);
		
		at: JdmColumn floatType 
		put: #(#float);
				
		at: JdmColumn decimalType
		put: #(#decimal);
		
		at: JdmColumn dateType
		put: #(#date);
		
		at: JdmColumn datetimeType
		put: #(#dateTime);
		
		at: JdmColumn timeType
		put: #(#time);
				
		at: JdmColumn enumType
		put: #(#enum);
		
		at: JdmColumn setType
		put: #(#set);
		
		at: JdmColumn tinyBlobType
		put: #(#tinyBlob);
		
		at: JdmColumn mediumBlobType
		put: #(#mediumBlob);
		
		at: JdmColumn longBlobType
		put: #(#longBlob);
		
		at: JdmColumn blobType
		put: #(#blob)
		
		"	
		at: JdmColumn timestampType 
		put: #(#timestamp);

		at: JdmColumn doubleType
		put: #(#double);
		"! !

!JdmTestFieldConverter methodsFor: 'Private' stamp: 'cwp 8/21/2002 17:28'!
createColumn
	^ self createColumnOfType: JdmColumn longType! !

!JdmTestFieldConverter methodsFor: 'Private' stamp: 'cwp 8/23/2002 01:26'!
createColumnOfType: type
	^ self 
		createColumnOfType: type
		flags: 0! !

!JdmTestFieldConverter methodsFor: 'Private' stamp: 'cwp 8/23/2002 01:14'!
createColumnOfType: type flags: flags
	^ JdmMockColumn new
		table: 'mockTable';
		name: 'mockColumn';
		size: 8;
		type:  type;
		flags: flags;
		decimalPlaces: 0! !

!JdmTestFieldConverter methodsFor: 'Running' stamp: 'cwp 8/22/2002 15:17'!
setUp
	support _ JdmMysqlTestSupport mysqlTestSupport.
	converter _ JdmFieldConverter fieldConverter.
	self buildTypeMap! !

!JdmTestFieldConverter methodsFor: 'Testing' stamp: 'cwp 8/23/2002 01:53'!
testBinaryNotNull
	| col val |
	col _ self 
		createColumnOfType: JdmColumn blobType
		flags: (JdmColumn binaryFlag + JdmColumn notNullFlag).
	val _ converter convert: nil from: col.
	self assert: val class = ByteArray.
	self assert: val isEmpty! !

!JdmTestFieldConverter methodsFor: 'Testing' stamp: 'cwp 8/23/2002 01:44'!
testBinaryValue
	| col val |
	col _ self 
		createColumnOfType: JdmColumn blobType
		flags: JdmColumn binaryFlag.			
	val _ converter convert: nil from: col.
	self assert: val = nil! !

!JdmTestFieldConverter methodsFor: 'Testing' stamp: 'cwp 8/21/2002 17:43'!
testDouble
	| col val |
	col _ self createColumnOfType: JdmColumn doubleType.
	val _ converter convert: '3.40282e+38'  from: col.
	self assert: val isFloat.
	self assert: val = 3.40282e+38! !

!JdmTestFieldConverter methodsFor: 'Testing' stamp: 'cwp 8/23/2002 01:55'!
testEmptyString
	| col val |
	col _ self 
		createColumnOfType: JdmColumn blobType
		flags: JdmColumn notNullFlag.			
	val _ converter convert: nil from: col.
	self assert: val = ''! !

!JdmTestFieldConverter methodsFor: 'Testing' stamp: 'cwp 8/22/2002 17:33'!
testNullValue
	| col val |
	typeMap keys do:
		[ :colType  | 
		col _ self createColumnOfType: JdmColumn longType.
		val _ converter convert: nil from: col.
		self assert: val = nil]! !

!JdmTestFieldConverter methodsFor: 'Testing' stamp: 'cwp 8/21/2002 18:03'!
testTimestamp
	| col val |
	col _ self createColumnOfType: JdmColumn timestampType.
	val _ converter convert: '20020203114521'  from: col.
	self assert: val = (TimeStamp fromString: '2-3-2002 11:45:21 am')! !

!JdmTestFieldConverter methodsFor: 'Testing' stamp: 'cwp 8/22/2002 17:37'!
testValidValues
	| col val raw mysql |
	typeMap keysAndValuesDo:
		[ :colType :dataTypes | 
		col _ self createColumnOfType: colType.
		dataTypes do:
			[ :type |  
			raw _ support randomValueForType: type.
			mysql _ (converter convertToMysql: raw) withoutQuoting.			
			val _ converter convert: mysql  from: col.
			self assert: val = raw]]! !

!JdmTestFieldConverter methodsFor: 'Testing' stamp: 'cwp 8/21/2002 22:08'!
testZeroDate
	| col val |
	col _ self createColumnOfType: JdmColumn dateType.
	val _ converter convert: '0000-00-00'  from: col.
	self assert: val = nil.! !

TestCase subclass: #JdmTestTableOperations
	instanceVariableNames: 'connection testSupport testProgress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Tests'!

!JdmTestTableOperations class methodsFor: 'constants' stamp: 'cwp 8/20/2002 15:43'!
tableName
	^'TestTable'! !

!JdmTestTableOperations methodsFor: 'Private' stamp: 'cwp 8/21/2002 14:30'!
insertRow
	^ connection createStatement 
		executeQuery: testSupport insertIntoTable.
! !

!JdmTestTableOperations methodsFor: 'initialize-release' stamp: 'cwp 8/21/2002 14:07'!
setUp
	super setUp.
	testSupport := JdmMysqlTestSupport mysqlTestSupport.
	connection := JdmConnection on: 
		(JdmConnectionSpec new initialize
			database: 'TNTest';
			host: (NetNameResolver addressForName: 'trillian.whistler.com');
			user: 'tantalus';
			password: 'demo').
	connection createStatement executeQuery: testSupport createTable.! !

!JdmTestTableOperations methodsFor: 'initialize-release' stamp: 'cwp 8/21/2002 16:04'!
tearDown
	connection createStatement executeQuery: 'drop table ' , testSupport class tableName.
	connection close! !

!JdmTestTableOperations methodsFor: 'test' stamp: 'cwp 8/21/2002 15:14'!
testDeleteRows
	| result |
	self insertRow.
	result := connection createStatement 
				executeQuery: 'delete from ' , testSupport class tableName.
	self assert: result type = #update.
	self assert: result value = 0.
! !

!JdmTestTableOperations methodsFor: 'test' stamp: 'cwp 8/21/2002 16:10'!
testInsertAndSelect
	| resultSet count numColumns |
	1 to: testSupport class numRowsToInsert do: [:row | self insertRow].
	resultSet := connection createStatement 
		executeQuery: 'select * from ' , testSupport class tableName.

	self assert: resultSet isNil not.
	count := 0.
	numColumns := resultSet columns size.
	[resultSet next] whileTrue: 
			[1 to: numColumns
				do: [:columnNum | resultSet valueAt: columnNum].
			count := count + 1].

	self assert: count = testSupport class numRowsToInsert.! !

!JdmTestTableOperations methodsFor: 'test' stamp: 'cwp 8/21/2002 17:45'!
testInsertRow
	| result |
	result := self insertRow.
	self assert: result type = #insert.
	self assert: result value = 0.! !
JdmFieldConverter initialize!
JdmStatement initialize!
